/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
/* 
Module version: 3.00
*/
#include "project.h"
#include <MC_WDT.h>
#include <Ble_Application.h>
#include <Application.h>
#include <stdio.h>
#include <string.h>
#include <debug_serial.h>
#include "version.h"

uint16 displaydelay;
char *tstr;

extern cy_stc_ble_gap_peer_addr_info_t remote_peer_gap_param;
cy_stc_ble_rssi_info_t remote_peer_rssi_param;
float connIntv = 0;

_Bool GetRssiPeer_Fn_Success;
_Bool Remote_Peerbdhandle_Rx;
uint8 rssi_read_flag;


volatile uint32_t systick = 0;
/****************************************************************************/
void SysTick_isr()
{
Cy_GPIO_Inv(EVT_3_PORT, EVT_3_NUM);
	systick++;
	if((DeviceConnection==true) /*&& ((systick%30)==0)*/)
	{
		Cy_BLE_GetRssiPeer(conn_param.bdHandle);
Cy_GPIO_Write(EVT_1_PORT, EVT_1_NUM, 1);
	static cy_stc_ble_tx_pwr_config_param_t param;
		param.bleSsChId = CY_BLE_LL_CONN_CH_TYPE;
		param.bdHandle = conn_param.bdHandle;
		Cy_BLE_GetTxPowerLevel(&param);
Cy_GPIO_Write(EVT_2_PORT, EVT_2_NUM, 1);
	}
}

/****************************************************************************/
void print_BLE_GAP_connection()
{
	// Printout the GAP connection parameters
	if(conn_param.status==0) printf(".status = SUCCESS\r\n" );
	else printf(".status = Error:%d\r\n",conn_param.status);
	printf(".bdHandle = %d\r\n",conn_param.bdHandle);
	printf(".role = %s\r\n",(conn_param.role == CY_BLE_GAP_LL_ROLE_SLAVE ? "Slave" : "Master"));
	switch(conn_param.peerAddrType)
	{
	case CY_BLE_GAP_ADDR_TYPE_PUBLIC: tstr = "Public Addr"; break;
	case CY_BLE_GAP_ADDR_TYPE_RANDOM: tstr = "Random Addr"; break;
	case CY_BLE_GAP_ADDR_TYPE_PUBLIC_RPA: tstr = "Public RPA Addr"; break;
	case CY_BLE_GAP_ADDR_TYPE_RANDOM_RPA: tstr = "Random RPA Addr"; break;
	default:  tstr = "Unknown Addr type"; break;
	}
	printf(".peerAddrType = %s\r\n",tstr);

	printf(".peerAddr = ");	
	for(uint8 i=0;i<CY_BLE_BD_ADDR_SIZE;i++)
    {
		printf("%x:",conn_param.peerAddr[i]);
    }
	printf("\r\n");
	
	printf(".connIntv = %.2f ms\r\n", connIntv = ((float)conn_param.connIntv) * 1.25);
	printf(".connLatency = %d events\r\n",conn_param.connLatency);
	printf(".supervisionTO = %d ms\r\n",conn_param.supervisionTO*10);
	
	if(conn_param.role != CY_BLE_GAP_LL_ROLE_MASTER)
	{
	int16_t mc_acc = 0;
		switch((cy_en_ble_bless_wco_sca_cfg_t) conn_param.masterClockAccuracy)
		{
		case CY_BLE_LL_SCA_251_TO_500_PPM: mc_acc = 500; break;
		case CY_BLE_LL_SCA_151_TO_250_PPM: mc_acc = 250; break;
		case CY_BLE_LL_SCA_101_TO_150_PPM: mc_acc = 150; break;
		case CY_BLE_LL_SCA_076_TO_100_PPM: mc_acc = 100; break;
		case CY_BLE_LL_SCA_051_TO_075_PPM: mc_acc = 75;	break;
		case CY_BLE_LL_SCA_031_TO_050_PPM: mc_acc = 50;	break;
		case CY_BLE_LL_SCA_021_TO_030_PPM: mc_acc = 30;	break;
		case CY_BLE_LL_SCA_000_TO_020_PPM: mc_acc = 20;	break;
		case CY_BLE_LL_SCA_IN_PPM_INVALID: mc_acc = -1;	break;
		}
		printf(".masterClockAccuracy = %d ppm\r\n", mc_acc);
	}
}
/****************************************************************************/
void print_RSSI_TxPwlLevel(int8_t rssi, cy_en_ble_bless_pwr_lvl_t txpwrlvl)
{
int8 dBm = -128;
	switch(txpwrlvl)
	{
	case CY_BLE_LL_PWR_LVL_NEG_20_DBM: dBm = -20; break;
    case CY_BLE_LL_PWR_LVL_NEG_16_DBM: dBm = -16; break;
	case CY_BLE_LL_PWR_LVL_NEG_12_DBM: dBm = -12; break;
	case CY_BLE_LL_PWR_LVL_NEG_6_DBM: dBm = -6; break;
	case CY_BLE_LL_PWR_LVL_0_DBM: dBm = 0; break;
	case CY_BLE_LL_PWR_LVL_MAX: dBm = 4; break;
	default: dBm = -128; break;
	}
	printf("RSSI + TXPL = %d + %d dBm  SysTick=%lu\r\n", rssi, txpwrlvl, systick);
}

/****************************************************************************/
void init_UART()
{
    /* Initialize SCB for UART operation with GUI selected settings */
    (void) Cy_SCB_UART_Init(UART_HW, &UART_config, &UART_context);
    /* Enable UART */
    Cy_SCB_UART_Enable(UART_HW);
    
    /* \x1b[2J\x1b[;H - ANSI ESC sequence for clear screen */
    printf("\x1b[2J\x1b[;H");
    /* Send Project Name and version string */
    printf("\r%s Build:%s\r\n", TOSTRING(SW_TITLE), TOSTRING(SW_VER_REV_REL));
    /* Send welcome string */
    printf("RSSI search ... \r\n");
}

/****************************************************************************/
int main(void)
{
    /* Initialise MCWDT for periodic interrupt every 1 second */
    MC_WDT_initialise();
		
    /* Start Host of BLE Component and register generic event handler */
    Cy_BLE_Start(StackEventHandler);
    
    /* Register IAS event handler */
    Cy_BLE_IAS_RegisterAttrCallback(IasEventHandler);
    
    /* initialise UART with interruts disabled */
    init_UART();
	
    __enable_irq(); /* Enable global interrupts. */

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */ 
    
    uint8 Display_Remote_Addr=false;

    for(;;)
    {
        /* Place your application code here. */

	/* Cy_Ble_ProcessEvents() allows BLE stack to process pending events */
        Cy_BLE_ProcessEvents();
        
        /* Alert handler  */
        immediate_alert(); 
        
        if(DeviceConnection==true)
        {              	

			if(Display_Remote_Addr==false)
            {
				Display_Remote_Addr=true;      
				
				print_BLE_GAP_connection();
				
                if(conn_param.peerAddr != NULL)
                {
                    remote_peer_rssi_param.bdHandle=conn_param.bdHandle;
                    Remote_Peerbdhandle_Rx=true;
                }
                else
                {
                    Remote_Peerbdhandle_Rx=false;
                    
                    printf("Get peer bdhandle fail\r\n");                                     
                }
				Cy_SysTick_Init(CY_SYSTICK_CLOCK_SOURCE_CLK_LF, (uint32_t)(connIntv*(float)CYDEV_CLK_LFCLK__HZ)/1000);		// Reload = (connection Interval * CLK_LF)/1000
				Cy_SysTick_SetCallback(0, &SysTick_isr);
				Cy_SysTick_Enable();
            }
            
			// Get RSSI

			// Get Tx Pwr Level
			if( (rssi_ers == EVT_REQ_CMPLT)
			&& 	(conn_param.peerAddr != NULL) && (txpwrlvl_ers == EVT_REQ_CMPLT) 
			)
			{
				rssi_ers = EVT_REQ_ACTIVE; 
				txpwrlvl_ers = EVT_REQ_ACTIVE; 

				print_RSSI_TxPwlLevel(rssi, txpwrlvl);
			}
			
        }
        else
        {
            Display_Remote_Addr=false; 
            displaydelay=false;
            
            Remote_Peerbdhandle_Rx=false;            
            rssi_read_flag=false;
            GetRssiPeer_Fn_Success=false;    
			rssi_ers = EVT_REQ_CMPLT;
			txpwrlvl_ers = EVT_REQ_CMPLT;
			Cy_SysTick_Disable();			// Disable the SysTick isr
        }        
    }
}


/* [] END OF FILE */
